// CNC-v3.2.scad - Open source CNC machine
// Project page: www.HomoFaciens.de
// Date: 2016-10-11
// Author: Norbert Heinz



//Z axis +++++++++++++++++++++++++++++++++++++++++++++++++++++
translate([100,-7.5,37]) {
  translate([0,0,0]) {
    difference() {
      cube([31, 2, 2], center=true);
      cube([32, 1.6, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      linear_extrude(2.4, center = true) {
        text("  Z1", 2, halign = "left", valign = "center");
      }
    }
  }

  translate([0,0,20]) {
    difference() {
      cube([31, 2, 2], center=true);
      cube([32, 1.6, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      linear_extrude(2.4, center = true) {
        text("  Z2", 2, halign = "left", valign = "center");
      }
    }
  }

  translate([-12.5,0,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z3    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }

  translate([-6.5,0,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z4    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }

  translate([6.5,0,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z5    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  translate([12.5,0,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z6    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  

  //Ball bearings middle guide
  color( [0.0, 1.0, 0.0, 1.0] ) {
    
    translate([2.5,3,20]) {
      rotate([90,90,0]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
    translate([-2.5,3,20]) {
      rotate([90,90,0]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
    translate([2.5,3,0]) {
      rotate([90,90,0]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
    translate([-2.5,3,0]) {
      rotate([90,90,0]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
  }
  
  //Ball bearing mount 1
  translate([14.5,6,2]) {
    difference() {
      cube([2, 14, 2], center=true);
      cube([1.6, 15, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([0, 0, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z7", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  //Ball bearing
  color( [0.0, 1.0, 0.0, 1.0] ) {
    
    translate([12.5,3,2]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }

    translate([12.5,8,2]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
  }

  //Ball bearing mount 2
  translate([14.5,6,18]) {
    difference() {
      cube([2, 14, 2], center=true);
      cube([1.6, 15, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([0, 0, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z8", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  //Ball bearing
  color( [0.0, 1.0, 0.0, 1.0] ) {
    
    translate([12.5,3,18]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }

    translate([12.5,8,18]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
  }

  translate([-12.5,12,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([270, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z12", 2, halign = "right", valign = "center");
        }
      }
    }
  }

  translate([-12.5,8,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([270, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z13", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  //Ball bearing mount 3
  translate([-14.5,6,18]) {
    difference() {
      cube([2, 14, 2], center=true);
      cube([1.6, 15, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([0, 0, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z9", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  //Ball bearing
  color( [0.0, 1.0, 0.0, 1.0] ) {
    
    translate([-12.5,3,18]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }

    translate([-12.5,8,18]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
  }

  //Ball bearing mount 4
  translate([-14.5,6,2]) {
    difference() {
      cube([2, 14, 2], center=true);
      cube([1.6, 15, 1.6], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([0, 0, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z10", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  //Ball bearing
  color( [0.0, 1.0, 0.0, 1.0] ) {
    
    translate([-12.5,3,2]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }

    translate([-12.5,8,2]) {
      rotate([90,0,90]) {
        difference() {
          cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
          cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
        }
      }
    }
  }

  translate([12.5,12,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([90, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z11", 2, halign = "right", valign = "center");
        }
      }
    }
  }

  translate([12.5,8,10]) {
    difference() {
      cube([2, 2, 18], center=true);
      cube([1.6, 1.6, 21], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([90, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z14", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  translate([6.5,3,10]) {
    difference() {
      cube([2, 2, 22], center=true);
      cube([1.6, 1.6, 23], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z15    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }

  translate([2.5,3,10]) {
    difference() {
      cube([2, 2, 22], center=true);
      cube([1.6, 1.6, 23], center=true);
    }
    color( [1.0, 0.0, 0.0, 1.0] ) {
      rotate([180, 90, 90]) {
        linear_extrude(2.2, center = true) {
          text("Z16    ", 2, halign = "right", valign = "center");
        }
      }
    }
  }
  
  
}//End Z axis -----------------------------------------------


//Y axis
translate([100,1,15.5]) {


  //X axis ++++++++++++++++++++++++++++++++++++++++++++++++++
  translate([-12.5,-50,4.5]) {

      translate([17.5,0,1.0]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X1    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([-17.5,0,1.0]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X2    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([0,0,1.0]) {
        difference() {
          cube([33, 2, 2], center=true);
          cube([34, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X3    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      
      translate([0,13.5,-1.0]) {
        difference() {
          cube([41, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X4    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      

      translate([0,-13.5,-1.0]) {
        difference() {
          cube([41, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X5    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }


      //Ball bearing
      color( [0.0, 1.0, 0.0, 1.0] ) {
        
        translate([-17.5,2.5,-2]) {
          rotate([0,0,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([-17.5,-2.5,-2]) {
          rotate([0,0,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([17.5,2.5,-2]) {
          rotate([0,0,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([17.5,-2.5,-2]) {
          rotate([0,0,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }
        
      }
      

      //Ball bearing mount 1
      translate([-19.5,11.5,-3.25]) {
        difference() {
          cube([2, 2, 10.5], center=true);
          cube([1.6, 1.6, 13], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 90, 90]) {
            linear_extrude(2.2, center = true) {
              text(" X6", 2, halign = "left", valign = "center");
            }
          }
        }
      }
      
      //Ball bearing
      color( [0.0, 1.0, 0.0, 1.0] ) {
        
        translate([-19.5,9.5,-2]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([-19.5,9.5,-7]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }
      }


      //Ball bearing mount 2
      translate([19.5,11.5,-3.25]) {
        difference() {
          cube([2, 2, 10.5], center=true);
          cube([1.6, 1.6, 13], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 90, 90]) {
            linear_extrude(2.2, center = true) {
              text(" X7", 2, halign = "left", valign = "center");
            }
          }
        }
      }
      
      //Ball bearing
      color( [0.0, 1.0, 0.0, 1.0] ) {
        
        translate([19.5,9.5,-2]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([19.5,9.5,-7]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }
      }



      //Ball bearing mount 3
      translate([19.5,-11.5,-3.25]) {
        difference() {
          cube([2, 2, 10.5], center=true);
          cube([1.6, 1.6, 13], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([180, 90, 90]) {
            linear_extrude(2.2, center = true) {
              text(" X8", 2, halign = "left", valign = "center");
            }
          }
        }
      }
      
      //Ball bearing
      color( [0.0, 1.0, 0.0, 1.0] ) {
        
        translate([19.5,-9.5,-2]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([19.5,-9.5,-7]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }
      }
      
      //Ball bearing mount 4
      translate([-19.5,-11.5,-3.25]) {
        difference() {
          cube([2, 2, 10.5], center=true);
          cube([1.6, 1.6, 13], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([180, 90, 90]) {
            linear_extrude(2.2, center = true) {
              text(" X9", 2, halign = "left", valign = "center");
            }
          }
        }
      }
      
      //Ball bearing
      color( [0.0, 1.0, 0.0, 1.0] ) {
        
        translate([-19.5,-9.5,-2]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }

        translate([-19.5,-9.5,-7]) {
          rotate([90,90,0]) {
            difference() {
              cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
              cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
            }
          }
        }
      }

      translate([0,-9.5,-2]) {
        difference() {
          cube([41, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X10    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([0,9.5,-2]) {
        difference() {
          cube([41, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X11    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([0,-2.5,-2]) {
        difference() {
          cube([37, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X12    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      

      translate([0,-6,-2]) {
        difference() {
          cube([37, 2, 2], center=true);
          cube([42, 1.6, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 0]) {
            linear_extrude(2.2, center = true) {
              text("X13    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }


      //Table
      translate([16.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X14    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([12.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X15    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([8.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X16    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([4.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X17    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X18    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      
      translate([-4.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X19    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      
      translate([-8.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X20    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      translate([-12.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X21    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
      
      translate([-16.0,0,3.25]) {
        difference() {
          cube([2, 29, 2], center=true);
          cube([1.6, 30, 1.6], center=true);
        }
        color( [1.0, 0.0, 0.0, 1.0] ) {
          rotate([0, 0, 90]) {
            linear_extrude(2.2, center = true) {
              text("X22    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }

      
      
    }//End X-axis ---------------------------------------------------
  


    translate([3,9,0]) {
      difference() {
        cube([76, 2, 2], center=true);
        cube([77, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("Y1              ", 2, halign = "right", valign = "center");
        }
      }
    }

    translate([3,-9,0]) {
      difference() {
        cube([76, 2, 2], center=true);
        cube([77, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("Y2              ", 2, halign = "right", valign = "center");
        }
      }
    }

    translate([2,0,2]) {
      difference() {
        cube([74, 2, 2], center=true);
        cube([77, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("Y11    ", 2, halign = "right", valign = "center");
        }
      }
    }
    
    //Ladder
    translate([-34,0,0]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y3    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([-15,0,0]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y4    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([0,0,0]) {
      difference() {
        cube([2, 12, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y5    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([0,7,0]) {
      difference() {
        cube([18, 2, 2], center=true);
        cube([21, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
            text("Y6", 2, halign = "right", valign = "center");
        }
      }
    }

    translate([0,-7,0]) {
      difference() {
        cube([18, 2, 2], center=true);
        cube([21, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
            text("Y7", 2, halign = "right", valign = "center");
        }
      }
    }
    
    translate([15,0,0]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y8    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([31,0,0]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y9    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([38,0,0]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y10    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    //Free end thread
    translate([-36,0,1.5]) {
      difference() {
        cube([2, 2, 9], center=true);
        cube([1.6, 1.6, 21], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 270]) {
          linear_extrude(2.2, center = true) {
            text("   Y27", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      
      translate([-37.5,0,5.5]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }
    
    //Fixed end thread
    translate([38,0,5.5]) {
      difference() {
        cube([2, 26, 2], center=true);
        cube([1.6, 27, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y14    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([40,7,8.5]) {
      difference() {
        cube([2, 2, 20], center=true);
        cube([1.6, 1.6, 21], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y16", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    translate([40,-7,2.75]) {
      difference() {
        cube([2, 2, 7.5], center=true);
        cube([1.6, 1.6, 21], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y15", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    translate([36,7,2.75]) {
      difference() {
        cube([2, 2, 7.5], center=true);
        cube([1.6, 1.6, 21], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y12", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    translate([36,-7,2.75]) {
      difference() {
        cube([2, 2, 7.5], center=true);
        cube([1.6, 1.6, 21], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y13", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      
      translate([36.5,0,5.5]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      translate([39.5,0,5.5]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }
    
    
    //Ball bearing mount 1
    translate([-17,7,-6]) {
      difference() {
        cube([2, 2, 14], center=true);
        cube([1.6, 1.6, 15], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 180]) {
          linear_extrude(2.2, center = true) {
            text("Y17", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      
      translate([-14.5,7,-3]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      translate([-14.5,9,-8]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }


    //Ball bearing mount 2
    translate([-17,-7,-6]) {
      difference() {
        cube([2, 2, 14], center=true);
        cube([1.6, 1.6, 15], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("Y18", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([-14.5,-7,-3]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      //Ball bearing
      translate([-14.5,-9,-8]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    translate([-15,0,-8]) {
      difference() {
        cube([2, 20, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y19", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    translate([-15,0,-12]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y20", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    
    //Ball bearing mount 3
    translate([17,-7,-6]) {
      difference() {
        cube([2, 2, 14], center=true);
        cube([1.6, 1.6, 15], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("Y22", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([14.5,-7,-3]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      //Ball bearing
      translate([14.5,-9,-8]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    //Ball bearing mount 4
    translate([17,7,-6]) {
      difference() {
        cube([2, 2, 14], center=true);
        cube([1.6, 1.6, 15], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 90, 180]) {
          linear_extrude(2.2, center = true) {
            text("Y21", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([14.5,7,-3]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      //Ball bearing
      translate([14.5,9,-8]) {
        rotate([90,0,90]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    translate([15,0,-12]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y24", 2, halign = "center", valign = "center");
          }
        }
      }
    }

    translate([15,0,-8]) {
      difference() {
        cube([2, 20, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("Y23", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    

    translate([-6,0,-2.4]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y26    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([-2.5,0,-2.4]) {
      difference() {
        cube([2, 16, 2], center=true);
        cube([1.6, 21, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("Y25    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    

    //Ball bearing mount 5
//    translate([0,7,0]) {
//      difference() {
//        cube([10, 2, 2], center=true);
//        cube([11, 1.6, 1.6], center=true);
//      }
//    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([2.5,7,-2.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      //Ball bearing
      translate([-2.5,7,-2.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    //Ball bearing mount 6
//    translate([0,-7,0]) {
//      difference() {
//        cube([10, 2, 2], center=true);
//        cube([11, 1.6, 1.6], center=true);
//      }
//    }

    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([2.5,-7,-2.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      translate([-2.5,-7,-2.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }
        
}




//Main frame +++++++++++++++++++++++++++++++++++++++++++++++++++++
translate([0,0,0]) {
    translate([-14,-1,-10]) {
      difference() {
        cube([2, 82, 2], center=true);
        cube([1.6, 83, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("F1    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([14,-1,-10]) {
      difference() {
        cube([2, 82, 2], center=true);
        cube([1.6, 83, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F2    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([14,-1,10]) {
      difference() {
        cube([2, 82, 2], center=true);
        cube([1.6, 83, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F19    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-14,-1,10]) {
      difference() {
        cube([2, 82, 2], center=true);
        cube([1.6, 83, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("F20    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    //Middle guide Y axis
    translate([0,-11,12]) {
      difference() {
        cube([2, 62, 2], center=true);
        cube([1.6, 83, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F18    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    //Fixed end thread Y axis
    translate([0,23,15.5]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 0]) {
          linear_extrude(2.2, center = true) {
            text("F50    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([0,19,17.5]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 0, 0]) {
          linear_extrude(2.2, center = true) {
            text("F51    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([0,21.5,15.5]) {
        rotate([90,90,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }

      translate([0,24.5,15.5]) {
        rotate([90,90,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }
        
    
    //Free end thread Y axis 
    translate([0,-43,12]) {
      difference() {
        cube([2, 2, 10], center=true);
        cube([1.6, 1.6, 11], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F52", 2, halign = "center", valign = "center");
          }
        }
      }
    }
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([0,-44.5,15.5]) {
        rotate([90,90,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    //Fixed end thread Z axis 
    translate([0,-4,66]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F44", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,0,66]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F45", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-4,70]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F47", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,0,70]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F48", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-4,68]) {
      difference() {
        cube([2, 10, 2], center=true);
        cube([1.6, 11, 1.6], center=true);
      }
     translate([0,-4,0]) {
        color( [1.0, 0.0, 0.0, 1.0] ) {
          linear_extrude(0.2, center = true) {
            text("  F46", 2, halign = "left", valign = "center");
          }
        }
      }
    }
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([0,-7.5,66.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
      translate([0,-7.5,69.5]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }

    //Free end thread Z axis 
    translate([0,-7,47.5]) {
      difference() {
        cube([2, 4, 2], center=true);
        cube([1.6, 11, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(0.2, center = true) {
          text("  F49", 2, halign = "left", valign = "center");
        }
      }
    }
    //Ball bearing
    color( [0.0, 1.0, 0.0, 1.0] ) {
      translate([0,-7.5,46]) {
        rotate([0,0,0]) {
          difference() {
            cylinder($fn=60, h=1, r1=1.5, r2=1.5, center=true);
            cylinder($fn=60, h=3.2, r1=0.5, r2=0.5, center=true);
          }
        }
      }
    }
    
    //Ladder Z axis
    translate([0,-2,36]) {
      difference() {
        cube([22, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F40", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-2,47.5]) {
      difference() {
        cube([22, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F41", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-2,57.5]) {
      difference() {
        cube([22, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F42", 2, halign = "left", valign = "center");
        }
      }
    }

    translate([12,-2,52]) {
      difference() {
        cube([2, 2, 38], center=true);
        cube([1.6, 1.6, 41], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F38    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-12,-2,52]) {
      difference() {
        cube([2, 2, 38], center=true);
        cube([1.6, 1.6, 41], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F39    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    
    //Middle guide Z axis
    translate([0,-4,50]) {
      difference() {
        cube([2, 2, 30], center=true);
        cube([1.6, 1.6, 31], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F43    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    
    
    //Ladder Y axis
    translate([0,-41,10]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F14", 2, halign = "left", valign = "center");
        }
      }
    }

    translate([0,-21,10]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F15", 2, halign = "left", valign = "center");
        }
      }
    }

    translate([0,-1,10]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F16", 2, halign = "left", valign = "center");
        }
      }
    }

    translate([0,19,10]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F17", 2, halign = "left", valign = "center");
        }
      }
    }
    
    //Bottom ladder
    translate([0,-41,-8]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F3", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-21,-8]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F4", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,-1,-8]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F5", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,19,-8]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F6", 2, halign = "left", valign = "center");
        }
      }
    }
    translate([0,37,-8]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("  F7", 2, halign = "left", valign = "center");
        }
      }
    }

    //vertical ladder
    //right
    translate([12,-39,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F8    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([12,-19,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F9    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([12,1,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F10", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    //Left
    translate([-12,-39,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F11", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-12,-19,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F12", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-12,1,0]) {
      difference() {
        cube([2, 2, 22], center=true);
        cube([1.6, 1.6, 23], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F13", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    //Tower
    translate([12,39,29]) {
      difference() {
        cube([2, 2, 80], center=true);
        cube([1.6, 1.6, 81], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F23                ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([-12,39,29]) {
      difference() {
        cube([2, 2, 80], center=true);
        cube([1.6, 1.6, 81], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F24    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([12,21,29]) {
      difference() {
        cube([2, 2, 80], center=true);
        cube([1.6, 1.6, 81], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 90, 0]) {
          linear_extrude(2.2, center = true) {
            text("F21    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }

    translate([-12,21,29]) {
      difference() {
        cube([2, 2, 80], center=true);
        cube([1.6, 1.6, 81], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([0, 270, 0]) {
          linear_extrude(2.2, center = true) {
            text("F22    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    
    //Side ladders tower
    //right
    translate([10,17.5,68]) {
      difference() {
        cube([2, 45, 2], center=true);
        cube([1.6, 46, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F25    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([10,18.5,49.5]) {
      difference() {
        cube([2, 43, 2], center=true);
        cube([1.6, 44, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F26    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([10,18.5,34]) {
      difference() {
        cube([2, 43, 2], center=true);
        cube([1.6, 44, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 90]) {
          linear_extrude(2.2, center = true) {
            text("F27    ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    //Left
    translate([-10,17.5,68]) {
      difference() {
        cube([2, 45, 2], center=true);
        cube([1.6, 46, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("F28       ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-10,18.5,49.5]) {
      difference() {
        cube([2, 43, 2], center=true);
        cube([1.6, 44, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("F29       ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    translate([-10,18.5,34]) {
      difference() {
        cube([2, 43, 2], center=true);
        cube([1.6, 44, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        rotate([90, 0, 270]) {
          linear_extrude(2.2, center = true) {
            text("F30        ", 2, halign = "right", valign = "center");
          }
        }
      }
    }
    //Rear
    translate([0,37,66]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F31", 2, halign = "right", valign = "center");
        }
      }
    }
    translate([0,37,51.5]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F32", 2, halign = "right", valign = "center");
        }
      }
    }
    translate([0,37,36]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F33", 2, halign = "right", valign = "center");
        }
      }
    }
    translate([0,37,12]) {
      difference() {
        cube([30, 2, 2], center=true);
        cube([31, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F34", 2, halign = "right", valign = "center");
        }
      }
    }

    //Middle ladder
    translate([0,19,66]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F35", 2, halign = "right", valign = "center");
        }
      }
    }
    translate([0,19,51.5]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F36", 2, halign = "right", valign = "center");
        }
      }
    }
    translate([0,19,36]) {
      difference() {
        cube([26, 2, 2], center=true);
        cube([27, 1.6, 1.6], center=true);
      }
      color( [1.0, 0.0, 0.0, 1.0] ) {
        linear_extrude(2.2, center = true) {
          text("F37", 2, halign = "right", valign = "center");
        }
      }
    }
    
    
    
    
    
    //Cross beams
    //Rear

    /*
    translate([0,40,53.5]) {
      cube([26, 2, 2], center=true);
    }

    translate([0,40,64]) {
      cube([26, 2, 2], center=true);
    }
    */
    //Hole distance 26,196373795
    translate([0,37.80,58.75]) {
      rotate([0,23.629377731,0]) {
        cube([28, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  23.629377731]) {
            linear_extrude(0.6, center = true) {
              text("C61    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,40.20,58.75]) {
      rotate([0,-23.629377731,0]) {
        cube([28, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  -23.629377731]) {
            linear_extrude(0.6, center = true) {
              text("C62    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([0,40,38]) {
      cube([26, 2, 2], center=true);
    }

    translate([0,40,47.5]) {
      cube([26, 2, 2], center=true);
    }
    */
    //Hole distance 25,811818998
    translate([0,37.80,42.75]) {
      rotate([0,21.595310449,0]) {
        cube([28, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  21.595310449]) {
            linear_extrude(0.6, center = true) {
              text("C63    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,40.20,42.75]) {
      rotate([0,-21.595310449,0]) {
        cube([28, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  -21.595310449]) {
            linear_extrude(0.6, center = true) {
              text("C64    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([0,40,32]) {
      cube([26, 2, 2], center=true);
    }

    translate([0,40,14]) {
      cube([26, 2, 2], center=true);
    }
    */
    //Hole distance 30
    translate([0,40.20,23.5]) {
      rotate([0,36.869897646,0]) {
        cube([32, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  36.869897646]) {
            linear_extrude(0.6, center = true) {
              text("C65    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,40.45,23.5]) {
      rotate([0,-36.869897646,0]) {
        cube([32, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0, -36.869897646]) {
            linear_extrude(0.6, center = true) {
              text("C66    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([0,40,10]) {
      cube([26, 2, 2], center=true);
    }

    translate([0,40,-6]) {
      cube([26, 2, 2], center=true);
    }
    */
    //Hole distance 28,844410204
    translate([0,40.20,2]) {
      rotate([0,33.690067526,0]) {
        cube([31, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0,  33.690067526]) {
            linear_extrude(0.6, center = true) {
              text("C67    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,37.80,2]) {
      rotate([0,-33.690067526,0]) {
        cube([31, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 180]) {
          rotate([0, 0, -33.690067526]) {
            linear_extrude(0.6, center = true) {
              text("C68    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }


    //Center
    
    /*
    translate([0,20,8]) {
      cube([26, 2, 2], center=true);
    }

    translate([0,20,-6]) {
      cube([26, 2, 2], center=true);
    }
    */
    //Hole distance 27,784887979
    translate([0,22.20,1]) {
      rotate([0,30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  -30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C1    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,19.80,1]) {
      rotate([0,-30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C2    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,2.20,1]) {
      rotate([0,30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  -30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C3    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-0.20,1]) {
      rotate([0,-30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C4    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,-17.80,1]) {
      rotate([0,30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  -30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C5    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-20.20,1]) {
      rotate([0,-30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C6    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,-37.80,1]) {
      rotate([0,30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  -30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C7    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-40.20,1]) {
      rotate([0,-30.256437164,0]) {
        cube([30, 0.40, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([90, 0, 0]) {
          rotate([0, 0,  30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C8    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    
    //Left

    /*
    translate([13,9.5,51.5]) {
      cube([2, 25, 2], center=true);
    }
    translate([13,9.5,64]) {
      cube([2, 25, 2], center=true);
    }
    */
    //Hole distance 26,177280225
    translate([10.80,9.5,57.75]) {
      rotate([28.523118606,0,0]) {
        cube([0.40, 28, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90+28.523118606]) {
            linear_extrude(0.6, center = true) {
              text("C59    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    /*
    translate([13,8.5,49.5]) {
      cube([2, 19, 2], center=true);
    }
    translate([13,8.5,34]) {
      cube([2, 19, 2], center=true);
    }
    */
    //Hole distance 23,005434141
    translate([8.80,8.5,41.75]) {
      rotate([-42.357454706,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90-42.357454706]) {
            linear_extrude(0.6, center = true) {
              text("C60    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,53.5]) {
      cube([2, 20, 2], center=true);
    }
    translate([13,30,64]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 20,838665984
    translate([10.80,30,58.75]) {
      rotate([30.256437164,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90+30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C41    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([13.5,30,58.75]) {
      rotate([-30.256437164,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90-30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C42    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,38]) {
      cube([2, 20, 2], center=true);
    }

    translate([13,30,47.5]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 20,353132437
    translate([10.80,30,42.75]) {
      rotate([27.824096384,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90+27.824096384]) {
            linear_extrude(0.6, center = true) {
              text("C43    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([13.20,30,42.75]) {
      rotate([-27.824096384,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90-27.824096384]) {
            linear_extrude(0.6, center = true) {
              text("C44    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,32]) {
      cube([2, 20, 2], center=true);
    }

    translate([13,30,14]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 25,455844123
    translate([13.20,30,23.5]) {
      rotate([45,0,0]) {
        cube([0.40, 27, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90+45]) {
            linear_extrude(0.6, center = true) {
              text("C45    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([10.80,30,23.5]) {
      rotate([-45,0,0]) {
        cube([0.40, 27, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90-45]) {
            linear_extrude(0.6, center = true) {
              text("C46    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,8]) {
      cube([2, 20, 2], center=true);
    }
    translate([13,30,-6]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 22,803508502
    translate([13.20,30,1]) {
      rotate([37.874983651,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90+37.874983651]) {
            linear_extrude(0.6, center = true) {
              text("C47    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([10.80,30,1]) {
      rotate([-37.874983651,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 90-37.874983651]) {
            linear_extrude(0.6, center = true) {
              text("C48    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,11,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,11,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([13.20,11,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C27    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([10.80,11,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, -34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C28    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,-9,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,-9,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([13.20,-9,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C29    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([10.80,-9,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, -34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C30    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,-29,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,-29,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([13.20,-29,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C31    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([10.80,-29,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 0]) {
          rotate([0, 0, -34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C32    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    




    //Right

    /*
    translate([13,9.5,51.5]) {
      cube([2, 25, 2], center=true);
    }
    translate([13,9.5,64]) {
      cube([2, 25, 2], center=true);
    }
    */
    //Hole distance 26,177280225
    translate([-10.80,9.5,57.75]) {
      rotate([28.523118606,0,0]) {
        cube([0.40, 28, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-28.523118606]) {
            linear_extrude(0.6, center = true) {
              text("C57    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    /*
    translate([13,8.5,49.5]) {
      cube([2, 19, 2], center=true);
    }
    translate([13,8.5,34]) {
      cube([2, 19, 2], center=true);
    }
    */
    //Hole distance 23,005434141
    translate([-8.80,8.5,41.75]) {
      rotate([-42.357454706,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90+42.357454706]) {
            linear_extrude(0.6, center = true) {
              text("C58    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,53.5]) {
      cube([2, 20, 2], center=true);
    }
    translate([13,30,64]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 20,838665984
    translate([-13.20,30,58.75]) {
      rotate([30.256437164,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C49    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-10.80,30,58.75]) {
      rotate([-30.256437164,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90+30.256437164]) {
            linear_extrude(0.6, center = true) {
              text("C50    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,38]) {
      cube([2, 20, 2], center=true);
    }

    translate([13,30,47.5]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 20,353132437
    translate([-13.20,30,42.75]) {
      rotate([27.824096384,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-27.824096384]) {
            linear_extrude(0.6, center = true) {
              text("C51    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-10.80,30,42.75]) {
      rotate([-27.824096384,0,0]) {
        cube([0.40, 22, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90+27.824096384]) {
            linear_extrude(0.6, center = true) {
              text("C52    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,32]) {
      cube([2, 20, 2], center=true);
    }

    translate([13,30,14]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 25,455844123
    translate([-13.20,30,23.5]) {
      rotate([45,0,0]) {
        cube([0.40, 27, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-45]) {
            linear_extrude(0.6, center = true) {
              text("C53    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-10.80,30,23.5]) {
      rotate([-45,0,0]) {
        cube([0.40, 27, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90+45]) {
            linear_extrude(0.6, center = true) {
              text("C54    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,30,8]) {
      cube([2, 20, 2], center=true);
    }
    translate([13,30,-6]) {
      cube([2, 20, 2], center=true);
    }
    */
    //Hole distance 22,803508502
    translate([-10.80,30,1]) {
      rotate([37.874983651,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-37.874983651]) {
            linear_extrude(0.6, center = true) {
              text("C55    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-13.20,30,1]) {
      rotate([-37.874983651,0,0]) {
        cube([0.40, 25, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90+37.874983651]) {
            linear_extrude(0.6, center = true) {
              text("C56    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,11,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,11,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([-10.80,11,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-34.992020199]) {
            linear_extrude(0.6, center = true) {
              text("C21    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-13.20,11,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C22    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,-9,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,-9,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([-10.80,-9,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-34.992020199]) {
            linear_extrude(0.6, center = true) {
              text("C23    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-13.20,-9,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C24    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([13,-29,8]) {
      cube([2, 22, 2], center=true);
    }
    translate([13,-29,-6]) {
      cube([2, 22, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([-10.80,-29,1]) {
      rotate([34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 90-34.992020199]) {
            linear_extrude(0.6, center = true) {
              text("C25    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([-13.20,-29,1]) {
      rotate([-34.992020199,0,0]) {
        cube([0.40, 26, 2], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 90, 180]) {
          rotate([0, 0, 34.992020199+90]) {
            linear_extrude(0.6, center = true) {
              text("C26    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    






    
    //Horizontal cross beams
    
    /*
    translate([0,21,69]) {
      cube([22, 2, 2], center=true);
    }
    translate([0,35,69]) {
      cube([22, 2, 2], center=true);
    }
    */
    //Hole distance 24,413111231
    translate([0,28,69.20]) {
      rotate([0,0,55.007979801]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90+55.007979801]) {
            linear_extrude(0.6, center = true) {
              text("C33    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,28,66.80]) {
      rotate([0,0,-55.007979801]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90-55.007979801]) {
            linear_extrude(0.6, center = true) {
              text("C34    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    translate([0,28,35.20]) {
      rotate([0,0,55.007979801]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90+55.007979801]) {
            linear_extrude(0.6, center = true) {
              text("C37    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,28,32.80]) {
      rotate([0,0,-55.007979801]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90-55.007979801]) {
            linear_extrude(0.6, center = true) {
              text("C38    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }


    /*
    translate([0,17,69]) {
      cube([22, 2, 2], center=true);
    }
    translate([0,2,69]) {
      cube([22, 2, 2], center=true);
    }
    */
    //Hole distance 25
    translate([0,9.5,69.20]) {
      rotate([0,0,53.130102354]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90+53.130102354]) {
            linear_extrude(0.6, center = true) {
              text("C35    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,9.5,66.80]) {
      rotate([0,0,-53.130102354]) {
        cube([2, 27, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90-53.130102354]) {
            linear_extrude(0.6, center = true) {
              text("C36    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([0,17,35]) {
      cube([22, 2, 2], center=true);
    }
    translate([0,0,35]) {
      cube([22, 2, 2], center=true);
    }
    */
    //Hole distance 26,248809497
    translate([0,8.5,32.40]) {
      rotate([0,0,49.635463427]) {
        cube([2, 28, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90+49.635463427]) {
            linear_extrude(0.6, center = true) {
              text("C39    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,8.5,32.80]) {
      rotate([0,0,-49.635463427]) {
        cube([2, 28, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90-49.635463427]) {
            linear_extrude(0.6, center = true) {
              text("C40    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    /*
    translate([0,19,8]) {
      cube([22, 2, 2], center=true);
    }
    translate([0,-1,9]) {
      cube([22, 2, 2], center=true);
    }
    */
    //Hole distance 28,284271247
    translate([0,9,9.20]) {
      rotate([0,0,47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 270 + 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C15    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,9,8.80]) {
      rotate([0,0,-47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90 - 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C16    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,-11,9.20]) {
      rotate([0,0,47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 270 + 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C17    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-11,8.80]) {
      rotate([0,0,-47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90 - 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C18    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,-31,9.20]) {
      rotate([0,0,47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 270 + 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C19    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-31,8.80]) {
      rotate([0,0,-47.726310994]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 0, 0]) {
          rotate([0, 0, 90 - 47.726310994]) {
            linear_extrude(0.6, center = true) {
              text("C20    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    //Bottom
    
    /*
    translate([0,19,-7]) {
      cube([22, 2, 2], center=true);
    }
    translate([0,-1,-7]) {
      cube([22, 2, 2], center=true);
    }
    */
    //Hole distance 28,284271247
    translate([0,9,-6.80]) {
      rotate([0,0,45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, 45]) {
            linear_extrude(0.6, center = true) {
              text("C9    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,9,-9.20]) {
      rotate([0,0,-45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, -45]) {
            linear_extrude(0.6, center = true) {
              text("C10    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }

    translate([0,-11,-6.80]) {
      rotate([0,0,45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, 45]) {
            linear_extrude(0.6, center = true) {
              text("C11    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-11,-9.20]) {
      rotate([0,0,-45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, -45]) {
            linear_extrude(0.6, center = true) {
              text("C12    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    translate([0,-31,-6.80]) {
      rotate([0,0,45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, 45]) {
            linear_extrude(0.6, center = true) {
              text("C13    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    translate([0,-31,-9.20]) {
      rotate([0,0,-45]) {
        cube([2, 30, 0.40], center=true);
      }
      color( [0.0, 1.0, 1.0, 1.0] ) {
        rotate([0, 180, 0]) {
          rotate([0, 0, -45]) {
            linear_extrude(0.6, center = true) {
              text("C14    ", 2, halign = "right", valign = "center");
            }
          }
        }
      }
    }
    
    
    
}

